﻿using System;
using System.Collections.Generic;
using System.Text;
using Squid;
using SampleControls;
using Microsoft.Xna.Framework;

namespace SquidXNA
{
    public class SampleScene : DrawableGameComponent
    {
        private SampleDesktop Desktop;

        public SampleScene(Game game)
            : base(game)
        {
        }

        protected override void LoadContent()
        {
            Desktop = new SampleDesktop { Name = "desk" };
            Desktop.ShowCursor = true;

            // -- Uncomment to create the style texture
            // PackTextures("SampleMap", 6);

            // -- Uncomment to load and apply the style texture
            MapStyles("SampleMap");

            base.LoadContent();
        }

        public override void Draw(GameTime time)
        {
            Desktop.Size = new Squid.Point(Game.GraphicsDevice.Viewport.Width, Game.GraphicsDevice.Viewport.Height);
            Desktop.Update();
            Desktop.Draw();

            int tex = GuiHost.Renderer.GetTexture("xna_logo.png");
            GuiHost.Renderer.StartBatch();
            GuiHost.Renderer.DrawTexture(tex, Game.GraphicsDevice.Viewport.Width - 130, Game.GraphicsDevice.Viewport.Height - 80, 128, 128, new UVCoords(0, 0, 1, 1), -1);
            GuiHost.Renderer.EndBatch(true);
        }

        private void MapStyles(string mapName)
        {
            StyleMap map = new StyleMap();
            map.LoadFile(AppDomain.CurrentDomain.BaseDirectory + "Content\\" + mapName + "Coords.xml");

            foreach (ControlStyle style in GuiHost.GetSkin().Styles.Values)
            {
                foreach (Style state in style.Styles.Values)
                {
                    if (string.IsNullOrEmpty(state.Texture))
                        continue;

                    if (map.Contains(state.Texture))
                    {
                        state.TextureUV = map.GetUVCoords(state.Texture);
                        state.Texture = mapName + ".png";
                    }
                }
            }
        }
    }
}
